<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegB360 extends Record {
    protected $templateColumns = [
       
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "date_occur",
            'position' => 5,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "number_check",
            'position' => 13,
            'size' => 6,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "alinea",
            'position' => 19,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "amount",
            'position' => 21,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "currency_type",
            'position' => 25,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "value",
            'position' => 28,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "bank",
            'position' => 37,
            'size' => 30,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "agency",
            'position' => 67,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "city",
            'position' => 71,
            'size' => 25,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "state",
            'position' => 96,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "occur_amount",
            'position' => 98,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "type_account",
            'position' => 103,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "account",
            'position' => 104,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "filler_1",
            'position' => 113,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

    ];


    public function __construct($values = null) {
        $this->createColumns();
    }


}
