<?php

namespace Schaffen\SerasaRemessa\Http\Basic\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class MainBlock extends Record {
    protected $templateColumns = [
        [
            'name' => "product_code", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC, 
            'position' => 1, 
            'size' => 4
        ],
        [
                'name' => "caller_station", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 5, 
                'size' => 6
        ],
        [
                'name' => "document", 
                'type' => RecordColumn::TYPE_NUMERIC, 
                'position' => 11, 
                'size' => 15
        ],
        [
                'name' => "person_type", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 26, 
                'size' => 1
        ],
        [
                'name' => "base_cons", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 27, 
                'size' => 6
        ],
        [
                'name' => "modality", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 33, 
                'size' => 2
        ],
        [
                'name' => "query_value", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 35, 
                'size' => 7
        ],
        [
                'name' => "cost_center", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 42, 
                'size' => 12
        ],
        [
                'name' => "encoded", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 54, 
                'size' => 1
        ],
        [
                'name' => "number_of_records", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 55, 
                'size' => 2
        ],
        [
                'name' => "dialogue", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 57, 
                'size' => 1
        ],
        [
                'name' => "role", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 58, 
                'size' => 3
        ],
        [
                'name' => "query_type", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 61, 
                'size' => 1
        ],
        [
                'name' => "update", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 62, 
                'size' => 1
        ],
        [
                'name' => "ident_term", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 63, 
                'size' => 18
        ],
        [
                'name' => "rescli", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 81, 
                'size' => 10
        ],
        [
                'name' => "delts", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 91, 
                'size' => 1
        ],
        [
                'name' => "cobra", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 92, 
                'size' => 1
        ],
        [
                'name' => "passa", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 93, 
                'size' => 1
        ],
        [
                'name' => "cons_collec", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 94, 
                'size' => 1
        ],
        [
                'name' => "localizator", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 95, 
                'size' => 1
        ],
        [
                'name' => "creditor_document", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 96, 
                'size' => 9
        ],
        [
                'name' => "check_amount", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 105, 
                'size' => 2
        ],
        [
                'name' => "end_tel", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 107, 
                'size' => 1
        ],
        [
                'name' => "qtd_cho1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 108, 
                'size' => 2
        ],
        [
                'name' => "sco_cho1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 110, 
                'size' => 1
        ],
        [
                'name' => "tar_cho1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 111, 
                'size' => 1
        ],
        [
                'name' => "nao_cobr_bureau", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 112, 
                'size' => 1
        ],
        [
                'name' => "auto_posit", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 113, 
                'size' => 1
        ],
        [
                'name' => "bureau_via_site_transacional", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 114, 
                'size' => 1
        ],
        [
                'name' => "quer_tel_9_dig_x", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 115, 
                'size' => 1
        ],
        [
                'name' => "cta_corrent", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 116, 
                'size' => 10
        ],
        [
                'name' => "dg_cta_corr", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 126, 
                'size' => 1
        ],
        [
                'name' => "agency", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 127, 
                'size' => 4
        ],
        [
                'name' => "alert", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 131, 
                'size' => 1
        ],
        [
                'name' => "logon", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 132, 
                'size' => 8
        ],
        [
                'name' => "via_internet", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 140, 
                'size' => 1
        ],
        [
                'name' => "response", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 141, 
                'size' => 1
        ],
        [
                'name' => "periododocompro", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 142, 
                'size' => 1
        ],
        [
                'name' => "periodoendereco", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 143, 
                'size' => 1
        ],
        [
                'name' => "backtest", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 144, 
                'size' => 1
        ],
        [
                'name' => "dtquality", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 145, 
                'size' => 1
        ],
        [
                'name' => "prdorigem", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 146, 
                'size' => 2
        ],
        [
                'name' => "trndorigem", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 148, 
                'size' => 4
        ],
        [
                'name' => "consultante", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 152, 
                'size' => 15
        ],
        [
                'name' => "tp_or", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 167, 
                'size' => 1
        ],
        [
                'name' => "cnpj_softw", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 168, 
                'size' => 9
        ],
        [
                'name' => "blank_1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 177, 
                'size' => 15
        ],
        [
                'name' => "qtd_compr", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 192, 
                'size' => 2
        ],
        [
                'name' => "negativos", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 194, 
                'size' => 1
        ],
        [
                'name' => "cheque", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 195, 
                'size' => 1
        ],
        [
                'name' => "data_consul", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 196, 
                'size' => 8
        ],
        [
                'name' => "hora_consul", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 204, 
                'size' => 6
        ],
        [
                'name' => "total_reg", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 210, 
                'size' => 4
        ],
        [
                'name' => "qtd_reg1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 214, 
                'size' => 4
        ],
        [
                'name' => "cod_tab", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 218, 
                'size' => 4
        ],
        [
                'name' => "itemtsdados", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 222, 
                'size' => 4
        ],
        [
                'name' => "ts_dados", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 226, 
                'size' => 16
        ],
        [
                'name' => "ts_score1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 242, 
                'size' => 16
        ],
        [
                'name' => "ts_bp49", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 258, 
                'size' => 16
        ],
        [
                'name' => "ts_autor", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 274, 
                'size' => 16
        ],
        [
                'name' => "itemts_autor", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 290, 
                'size' => 4
        ],
        [
                'name' => "itemsts_scor1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 294, 
                'size' => 4
        ],
        [
                'name' => "itemts_bp49", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 298, 
                'size' => 4
        ],
        [
                'name' => "itemts_dados2", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 302, 
                'size' => 4
        ],
        [
                'name' => "ts_dados2", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 306, 
                'size' => 16
        ],
        [
                'name' => "fase_1", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 322, 
                'size' => 1
        ],
        [
                'name' => "fase_2", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 323, 
                'size' => 1
        ],
        [
                'name' => "dttabela", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 324, 
                'size' => 30
        ],
        [
                'name' => "cod_aut", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 354, 
                'size' => 1
        ],
        [
                'name' => "operid", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 355, 
                'size' => 3
        ],
        [
                'name' => "reci_compr", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 358, 
                'size' => 1
        ],
        [
                'name' => "reci_pagto", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 359, 
                'size' => 1
        ],
        [
                'name' => "blank_2", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 360, 
                'size' => 38
        ],
        [
                'name' => "acess_rechq", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 398, 
                'size' => 1
        ],
        [
                'name' => "tem_ocor_rechq", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 399, 
                'size' => 1
        ],
        [
                'name' => "reservado", 
                'type' => RecordColumn::TYPE_ALPHANUMERIC, 
                'position' => 400, 
                'size' => 1
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    private function setValues($values) {
        $values['product_code'] = "B49C";
        $values['caller_station'] = "";
        $values['person_type'] = "F";
        $values['base_cons'] = "C";
        $values['modality'] = "FI";
        $values['query_value'] = "0001000";
        $values['cost_center'] = "000000000000"; // deve ser informado?
        $values['encoded'] = "N";
        $values['number_of_records'] = "99";
        $values['dialogue'] = "S";
        $values['role'] = "INI";
        $values['query_type'] = "A";
        $values['update'] = "N";
        $values['ident_term'] = "";
        $values['rescli'] = "";
        $values['delts'] = "";
        $values['cobra'] = "";
        $values['passa'] = "";
        $values['cons_collec'] = "";
        $values['localizator'] = "";
        $values['creditor_document'] = "";
        $values['check_amount'] = "";
        $values['end_tel'] = "N";
        $values['qtd_cho1'] = "";
        $values['sco_cho1'] = "";
        $values['tar_cho1'] = "";
        $values['nao_cobr_bureau'] = "";
        $values['auto_posit'] = "";
        $values['bureau_via_site_transacional'] = "";
        $values['quer_tel_9_dig_x'] = "";
        $values['cta_corrent'] = "";
        $values['dg_cta_corr'] = "";
        $values['agency'] = "";
        $values['alert'] = "S";
        $values['logon'] = "";
        $values['via_internet'] = "";
        $values['response'] = "";
        $values['periododocompro'] = "";
        $values['periodoendereco'] = "";
        $values['backtest'] = "";
        $values['dtquality'] = "";
        $values['prdorigem'] = "";
        $values['trndorigem'] = "";
        $values['consultante'] = "";
        $values['tp_or'] = "";
        $values['cnpj_softw'] = "";
        $values['blank_1'] = "";
        $values['qtd_compr'] = "";
        $values['negativos'] = "";
        $values['cheque'] = "";
        $values['data_consul'] = "";
        $values['hora_consul'] = "";
        $values['total_reg'] = "";
        $values['qtd_reg1'] = "";
        $values['cod_tab'] = "";
        $values['itemtsdados'] = "";
        $values['ts_dados'] = "";
        $values['ts_score1'] = "";
        $values['ts_bp49'] = "";
        $values['ts_autor'] = "";
        $values['itemts_autor'] = "";
        $values['itemsts_scor1'] = "";
        $values['itemts_bp49'] = "";
        $values['itemts_dados2'] = "";
        $values['ts_dados2'] = "";
        $values['fase_1'] = "";
        $values['fase_2'] = "";
        $values['dttabela'] = "";
        $values['cod_aut'] = "";
        $values['operid'] = "";
        $values['reci_compr'] = "";
        $values['reci_pagto'] = "";
        $values['blank_2'] = "";
        $values['acess_rechq'] = "";
        $values['tem_ocor_rechq'] = "";
        $values['reservado'] = "";

        $this->setColumnsValues($values);
    }
}