<?php 

namespace Schaffen\SerasaRemessa\Http\Basic;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\ConfN20000;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\MainBlock;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\RegN001;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\RegN003;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\RegP002;


class Response {
    private $requestBlocks = [];
    private $responseBlocks = [];

    private $validBlocks = [
        'B49C' => MainBlock::class,
        'N001' => RegN001::class,
        'P002' => RegP002::class,
        'N003' => RegN003::class,
        'N20000' => ConfN20000::class,
    ];

    public static function load($body) {
        $mainBlock = substr($body, 0, 400);
        $response = new self();
        $response->loadBlocks(array_merge([$mainBlock], str_split(substr($body, 400), 115)));
        return $response;
    }

    private function loadBlocks($blocks) {
        foreach($blocks as $strBlock) {
            $blockCode = substr($strBlock, 0, 4);
            if(isset($this->validBlocks[$blockCode])) {
                $block = new $this->validBlocks[$blockCode]();
                $block->load($strBlock);
                array_push($this->requestBlocks, $block);
            }
            
            $blockCode = substr($strBlock, 0, 6);
            if(isset($this->validBlocks[$blockCode])) {
                $block = new $this->validBlocks[$blockCode]();
                $block->load($strBlock);
                array_push($this->responseBlocks, $block);
            }


        }
    }
}