<?php

namespace Schaffen\SerasaRemessa\Utils;

class Record {

    /**
     * @var array
     */
    private $columns = [];

    protected $templateColumns = [];

    protected function setColumn($name, RecordColumn $recordColumn) {
        $this->columns[$name] = $recordColumn;
    }

    protected function createColumns() {
        foreach($this->templateColumns as $column) {
            $this->setColumn($column['name'], new RecordColumn(null, $column['type'], $column['position'], $column['size']));
        }
    }

    protected function setColumnsValues($values) {
        foreach($values as $key => $value) {
            $this->getColumn($key)->setValue($value);
        }
    }

    public function load($recordString) {
        foreach($this->templateColumns as $column) {
            $value = substr($recordString, $column['position'] - 1, $column['size']);
            $this->getColumn($column['name'])->setValue($value);
        }
    }

    public function toString() {
        $headerString = '';
        foreach($this->columns as $column){
            $headerString .= $column->getFormatedValue();
        }

        return $headerString;
    }

    public function getColumn($name) {
        if(!isset($this->columns[$name])) {
            throw new \Exception("Column '{$name}' does not exists"); 
        }

        return $this->columns[$name];
    }

    public function getValues() {
        return array_map(function($item) {
            return $item->getValue();
        }, $this->columns);
    }
}